/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-05-07 15:58:32 UTC)
 * on 2013-05-09 at 19:37:48 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.books.model;

/**
 * Model definition for Volumeannotations.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Volumeannotations extends com.google.api.client.json.GenericJson {

  /**
   * A list of volume annotations.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Volumeannotation> items;

  /**
   * Resource type
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Token to pass in for pagination for the next page. This will not be present if this request
   * does not have more results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The total number of volume annotations found.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer totalItems;

  /**
   * The version string for all of the volume annotations in this layer (not just the ones in this
   * response). Note: the version string doesn't apply to the annotation data, just the information
   * in this response (e.g. the location of annotations in the book).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String version;

  /**
   * A list of volume annotations.
   * @return value or {@code null} for none
   */
  public java.util.List<Volumeannotation> getItems() {
    return items;
  }

  /**
   * A list of volume annotations.
   * @param items items or {@code null} for none
   */
  public Volumeannotations setItems(java.util.List<Volumeannotation> items) {
    this.items = items;
    return this;
  }

  /**
   * Resource type
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Resource type
   * @param kind kind or {@code null} for none
   */
  public Volumeannotations setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Token to pass in for pagination for the next page. This will not be present if this request
   * does not have more results.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * Token to pass in for pagination for the next page. This will not be present if this request
   * does not have more results.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public Volumeannotations setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * The total number of volume annotations found.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getTotalItems() {
    return totalItems;
  }

  /**
   * The total number of volume annotations found.
   * @param totalItems totalItems or {@code null} for none
   */
  public Volumeannotations setTotalItems(java.lang.Integer totalItems) {
    this.totalItems = totalItems;
    return this;
  }

  /**
   * The version string for all of the volume annotations in this layer (not just the ones in this
   * response). Note: the version string doesn't apply to the annotation data, just the information
   * in this response (e.g. the location of annotations in the book).
   * @return value or {@code null} for none
   */
  public java.lang.String getVersion() {
    return version;
  }

  /**
   * The version string for all of the volume annotations in this layer (not just the ones in this
   * response). Note: the version string doesn't apply to the annotation data, just the information
   * in this response (e.g. the location of annotations in the book).
   * @param version version or {@code null} for none
   */
  public Volumeannotations setVersion(java.lang.String version) {
    this.version = version;
    return this;
  }

  @Override
  public Volumeannotations set(String fieldName, Object value) {
    return (Volumeannotations) super.set(fieldName, value);
  }

  @Override
  public Volumeannotations clone() {
    return (Volumeannotations) super.clone();
  }

}
